--- rbwebkitgtk.c.old	2009-09-24 22:22:03.000000000 +0200
+++ rbwebkitgtk.c	2009-10-12 12:28:20.000000000 +0200
@@ -30,10 +30,12 @@
 
 #include "webkit/webkit.h"
 #include "webkit/webkitwebview.h"
+#include "webkit/webkitwebframe.h"
 
 #include "rbwebkitgtkversion.h"
 
 #define _WEBVIEW_SELF(s) (WEBKIT_WEB_VIEW(RVAL2GOBJ(s)))
+#define _WEBFRAME_SELF(s) (WEBKIT_WEB_FRAME(RVAL2GOBJ(s)))
 /* #define _HISTITEM_SELF(s) (WEBKIT_WEB_HISTORY_ITEM(RVAL2GOBJ(s))) */
 /* #define _BFLIST_SELF(s) (WEBKIT_WEB_BACK_FORWARD_LIST(RVAL2GOBJ(s))) */
 
@@ -259,6 +261,24 @@
     return self;
 }
 
+
+/*
+ * Method: print
+ *
+ * Prints the frame.
+ *
+ * Returns: self.
+ *
+ */
+static VALUE
+wk_webkit_web_frame_print(self)
+    VALUE self;
+{
+    webkit_web_frame_print(_WEBFRAME_SELF(self));
+    return self;
+}
+
+
 /*
  * Method: load_html_string
  *
@@ -699,6 +719,55 @@
 /*     return CSTR2RVAL(uri); */
 /* } */
 
+
+/*
+ * Method: get_main_frame
+ *
+ * Returns: the main frame of view.
+ *
+ */
+static VALUE
+wk_webkit_web_view_get_main_frame(self)
+    VALUE self;
+{
+    WebKitWebFrame* main_frame;
+    main_frame = (WebKitWebFrame *) webkit_web_view_get_main_frame(_WEBVIEW_SELF(self));
+    return GOBJ2RVAL(main_frame);
+}
+
+
+/*
+ * Method: get_title
+ *
+ * Returns: the title value.
+ *
+ */
+static VALUE
+wk_webkit_web_frame_get_title(self)
+    VALUE self;
+{
+    gchar* title;
+    title = (gchar *) webkit_web_frame_get_title(_WEBFRAME_SELF(self));
+    return CSTR2RVAL(title);
+}
+
+
+/*
+ * Method: get_title
+ *
+ * Returns: the title value.
+ *
+ */
+static VALUE
+wk_webkit_web_frame_get_name(self)
+    VALUE self;
+{
+    gchar* name;
+    name = (gchar *) webkit_web_frame_get_name(_WEBFRAME_SELF(self));
+    return CSTR2RVAL(name);
+}
+
+
 /*
  * Method: get_last_visited_time_in_seconds
  *
@@ -1015,7 +1084,7 @@
     rb_define_method(rb_cWebView, "search_text", wk_webview_search_text, 4);
     rb_define_method(rb_cWebView, "mark_text_matches_with_limit", wk_webview_mark_text_matches_with_limit, 3);
     rb_define_method(rb_cWebView, "set_highlight_text_matches", wk_webview_set_highlight_text_matches, 1);
-    rb_define_method(rb_cWebView, "unmark_text_matches", wk_webview_unmark_text_matches, 1);
+    rb_define_method(rb_cWebView, "unmark_text_matches", wk_webview_unmark_text_matches, 0);
     rb_define_method(rb_cWebView, "can_cut_clipboard?", wk_webview_can_cut_clipboard, 0);
     rb_define_method(rb_cWebView, "can_copy_clipboard?", wk_webview_can_copy_clipboard, 0);
     rb_define_method(rb_cWebView, "can_paste_clipboard?", wk_webview_can_paste_clipboard, 0);
@@ -1032,9 +1101,18 @@
 /*     rb_define_method(rb_cWebView, "get_paste_target_list", wk_webview_get_paste_target_list, 0); */
 /*     rb_define_method(rb_cWebView, "get_transparent", wk_webview_get_transparent, 0); */
 /*     rb_define_method(rb_cWebView, "set_transparent", wk_webview_set_transparent, 1); */
+     rb_define_method(rb_cWebView, "get_main_frame", wk_webkit_web_view_get_main_frame, 0);
 
     G_DEF_SETTERS(rb_cWebView);
 
+    VALUE rb_cWebFrame = G_DEF_CLASS(WEBKIT_TYPE_WEB_FRAME, "WebFrame", rb_mWebKit);
+
+     rb_define_method(rb_cWebFrame, "get_title", wk_webkit_web_frame_get_title, 0);
+     rb_define_method(rb_cWebFrame, "get_name", wk_webkit_web_frame_get_name, 0);
+     rb_define_method(rb_cWebFrame, "print", wk_webkit_web_frame_print, 0);
+
+    G_DEF_SETTERS(rb_cWebFrame);
+
 /*     VALUE rb_cWebHistoryItem = G_DEF_CLASS(WEBKIT_TYPE_WEB_HISTORY_ITEM, "WebHistoryItem", rb_mWebKit); */
 /*     rb_define_method(rb_cWebHistoryItem, "initialize", wk_histitem_initialize, 2); */
 /*     rb_define_method(rb_cWebHistoryItem, "get_title", wk_histitem_get_title, 0); */
